''' The following code checks that past CDE results are the same current CDE
results (on the same dataset with the same parameters), within a tolerance. 

This code is pretty sketchy and doesn't work that well. I haven't figured out a
better way to regression test the CDE though. 

The 'correct' results to compare against are generated by running the
generate_for_cde_regression file. 
'''

import os
import unittest

import numpy as np

import cfl.cond_density_estimation
from cfl.dataset import Dataset
from cdes_for_testing import cde_input_shapes
import generate_for_cde_regression as gc 





def make_cde_regression_tests(cond_exp_class):

    # generic test class for any CondExpBase descendant 
    # (passed in as cond_exp_class)
    class CondExpRegressionTests(unittest.TestCase):

        def setUp(self):
            # create same CDE setup as in original 
            X, Y = gc.generate_vb_data()
            cde_params = gc.get_params()
            self.ceb, self.dataset = gc.setup_CDE_data(X, Y, cde_input_shapes, cond_exp_class, cde_params)
        

        # load the results to compare against 
        def load_correct_results(self, ceb): 
            self.og_results = np.load(os.path.join(gc.RESOURCE_PATH, ceb.name + '_pyx.npy'))


        def test_cde_regression(self):
            self.setUp()
            self.load_correct_results(self.ceb)

            # train the CDE 
            results = self.ceb.train(self.dataset)['pyx']

            # # check that the pyx generated by the CDE this time and the original
            # # results are within 25% tolerance of each other 
            # assert np.allclose(self.og_results, results, rtol=0.25, atol=0, equal_nan=False), "Results for {} not within tolerance".format(self.ceb.name)
            # # ^ this test doesn't work (the CDE results are too variable)

            # compute the mean for each feature in Y 
            featurewise_means_og = np.mean(self.og_results, axis=1)
            featurewise_means_new = np.mean(results, axis=1)
            
            # compare that the means are the same within a 15% tolerance 
            assert np.allclose(featurewise_means_og, featurewise_means_new, rtol=0.15, atol=0, equal_nan=False), "Results for {} not within tolerance".format(self.ceb.name)


        ### TRAIN ############################################################

    return CondExpRegressionTests


for cond_exp_class in cde_input_shapes:
    class ConcreteRegressionTests(make_cde_regression_tests(cond_exp_class)):
        pass




